#!/usr/bin/sh
DEFMT_LOG=debug cargo build --release
if [ $? -ne 0 ]
then
    # Can't use $? because the check itself also updates the return code
    exit 1
fi

# Account for different toolchains
if command -v riscv64-unknown-elf-objcopy
then
    objcopy=riscv64-unknown-elf-objcopy
else
    objcopy=riscv64-linux-gnu-objcopy
fi

$objcopy -S -O binary target/riscv32i-unknown-none-elf/release/fw fw.bin
