use core::{any::Any, fmt::Write};

use defmt;

use crate::uart::LitexUart;
use core::arch::asm;

#[defmt::global_logger]
struct DefmtLogger;

unsafe impl defmt::Logger for DefmtLogger {
    fn acquire() {
        // Sync methods left empty because we don't use any interrupts
    }

    unsafe fn flush() {
        // Sync methods left empty because we don't use any interrupts
    }

    unsafe fn release() {
        // Sync methods left empty because we don't use any interrupts
    }

    unsafe fn write(bytes: &[u8]) {
        static mut UART: Option<LitexUart> = None;
        if UART.is_none() {
            UART = Some(LitexUart::new(0xf000_4800));
        }

        let mut dev = UART.unwrap();
        for byte in bytes {
            while let Err(_) = dev.try_put_char(*byte) {}
        }
    }
}
